package cn.itrunner.proxyTest;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

public class LogHandler implements InvocationHandler {

    private Object delegate;

    public LogHandler(Object obj) {
        this.delegate = obj;
    }

    @Override
    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
        doBefore();

        Object result = method.invoke(delegate, args);

        after();

        return result;
    }

    private void doBefore() {
        System.out.println("before....");
    }

    private void after() {
        System.out.println("after....");
    }
}
